/*
 * Amiga MUD
 *
 * Copyright (c) 1999 by Chris Gray
 */

/*
 * Common/locations.m - properties that are location-type specific.
 */

public t_locations CreateTable()$
use t_locations

define t_locations p_pCurrentMode CreateThingProp()$

define t_locations p_lmIdleAction CreateActionProp()$
define t_locations p_lmActiveAction1 CreateActionProp()$
define t_locations p_lmActiveAction2 CreateActionProp()$

define t_locations p_lmGetLocation CreateActionProp()$
define t_locations p_lmGetAgentLocation CreateActionProp()$
define t_locations p_lmDoMove CreateActionProp()$
define t_locations p_lmTryToMove CreateActionProp()$
define t_locations p_lmMachineMove CreateActionProp()$
define t_locations p_lmGetObjectsHere CreateActionProp()$
define t_locations p_lmIsSceneryHere CreateActionProp()$
define t_locations p_lmCanSeeLocation CreateActionProp()$
define t_locations p_lmCanSeeHere CreateActionProp()$
define t_locations p_lmInitialButtonHandler CreateActionProp()$
define t_locations p_lmInitialMouseDownHandler CreateActionProp()$
define t_locations p_lmSaveLocation CreateActionProp()$
define t_locations p_lmSaveHere CreateActionProp()$
define t_locations p_lmForEachLocation CreateActionProp()$
define t_locations p_lmForEachHere CreateActionProp()$
define t_locations p_lmSayOthersHere CreateActionProp()$
define t_locations p_lmPoseOthersHere CreateActionProp()$
define t_locations p_lmShowOthersLocation CreateActionProp()$
define t_locations p_lmShowOthersHere CreateActionProp()$
define t_locations p_lmShowABHere CreateActionProp()$
define t_locations p_lmClearMap CreateActionProp()$
define t_locations p_lmDoAllHere CreateActionProp()$
define t_locations p_lmFindAgentHere CreateActionProp()$
define t_locations p_lmLookDirHere CreateActionProp()$
define t_locations p_lmDirImageHere CreateActionProp()$
define t_locations p_lmGetForSaleHere CreateActionProp()$
define t_locations p_lmShowHereToMe CreateActionProp()$
define t_locations p_lmShowExitsHere CreateActionProp()$
define t_locations p_lmDoLocationGetChecks CreateActionProp()$
define t_locations p_lmDoLocationDropChecks CreateActionProp()$
define t_locations p_lmDoLocationSayChecks CreateActionProp()$
define t_locations p_lmShowMe CreateActionProp()$
define t_locations p_lmUnShowMe CreateActionProp()$
define t_locations p_lmAddObjectLocation CreateActionProp()$
define t_locations p_lmDelObjectLocation CreateActionProp()$
define t_locations p_lmCanFollow CreateActionProp()$
define t_locations p_lmStartFollowing CreateActionProp()$
define t_locations p_lmStopFollowing CreateActionProp()$
define t_locations p_lmAgentStillFollowing CreateActionProp()$
define t_locations p_lmFollowingStep CreateActionProp()$
define t_locations p_lmFollowSaveLocation CreateActionProp()$
define t_locations p_lmLeaveMode CreateActionProp()$
define t_locations p_lmResumeMode CreateActionProp()$
define t_locations p_lmShowAgentView CreateActionProp()$
define t_locations p_lmPoofToAgent CreateActionProp()$
